#include <bits/stdc++.h>

using namespace std;

int rekurzija(vector<int> niz, int k, int odindeks, int doindeks)
{
    int zbir = 0;
    if(k > 0)
    {
        for(int i = odindeks; i < doindeks + 1; i++)
        {
            for(int j = i; j < doindeks + 1; j++)
            {
                zbir += rekurzija(niz, k-1, i, j);
            }
        }
    }
    else
    {
        for(int i = odindeks; i < doindeks + 1; i++)
        {
            zbir += niz[i];
        }
    }
    return zbir;
}

int main()
{
    int n, a, k, zbir;
    vector<int> niz;
    cin >> n >> k;
    for(int i = 0; i < n; i++)
    {
        cin >> a;
        niz.push_back(a);
    }
    zbir = rekurzija(niz, k, 0, n-1) % 1000000007;
    cout << zbir << endl;
    return 0;
}